Attribute VB_Name = "Adyen"
Sub Adyen_Makro()
    'Copyright BuchhaltungsButler 2017
    
    With Application
        Application.UseSystemSeparators = False
        .DecimalSeparator = "."
        .ThousandsSeparator = ","
    End With
    
    Columns("A:A").TextToColumns Destination:=Range("A1"), DataType:=xlDelimited, _
        TextQualifier:=xlDoubleQuote, ConsecutiveDelimiter:=False, Tab:=False, _
        Semicolon:=False, Comma:=True, Space:=False, Other:=False, FieldInfo _
        :=Array(Array(1, 1), Array(2, 1), Array(3, 1), Array(4, 1), Array(5, 1), Array(6, 1), _
        Array(7, 1), Array(8, 1), Array(9, 1), Array(10, 1), Array(11, 1), Array(12, 1), Array(13, 1 _
        ), Array(14, 1), Array(15, 1), Array(16, 1), Array(17, 1), Array(18, 1), Array(19, 1), Array _
        (20, 1), Array(21, 1), Array(22, 1), Array(23, 1), Array(24, 1), Array(25, 1), Array(26, 1), _
        Array(27, 1), Array(28, 1), Array(29, 1), Array(30, 1)), TrailingMinusNumbers:=True
    
    Range("A:A,B:B").Delete Shift:=xlToLeft
    Range("A1").Value = "Belegnummer"
    Range("B1").Value = "Empfnger/Zahlungspflichtiger"
    Range("C1").Value = "Auftragsart"
    Range("D1").Value = "Buchungsdatum"
    Range("F1").Value = "Verwendungszweck"
    Range("L1").Value = "Whrung"
    Columns("D:D").NumberFormat = "m/d/yyyy"
    
    Columns("U:U").Cut Destination:=Columns("X:X") '
    With Excel.ActiveSheet
        rowges = .Cells(.Rows.Count, 4).End(Excel.xlUp).Row
    End With
    Dim i As Integer
    For i = 1 To rowges
        Cells(i, 21).Value = "Batch: " & Cells(i, 24).Value
    Next i
    Cells(1, 21).Value = "Buchungstext"
    
    Range("H:H").Insert Shift:=xlToRight, CopyOrigin:=xlFormatFromLeftOrAbove
    Range("H1").Value = "Betrag"
    Range("E:E").Delete Shift:=xlToLeft
    
    Columns("M:M").TextToColumns Destination:=Range("M1"), DataType:=xlDelimited, _
        TextQualifier:=xlDoubleQuote, ConsecutiveDelimiter:=False, Tab:=False, _
        Semicolon:=False, Comma:=True, Space:=False, Other:=False, FieldInfo _
        :=Array(1, 1), TrailingMinusNumbers:=True

    For i = 1 To rowges
        If Cells(i, 10).Value = "" Then 'Gross Credit clear
            If Cells(i, 9).Value = "" Then 'Gross Debit clear
                If Cells(i, 14).Value = "" Then 'Net Credit clear
                    If Cells(i, 13).Value = "" Then 'Net Debit clear
                        Cells(i, 13).Value = "Kein Betrag gegeben"
                    Else: 'Net Debit
                        Cells(i, 13).Value = Cells(i, 13).Value * (-1)
                        Cells(i, 7).Value = Cells(i, 13).Value
                    End If
                Else: 'Net Credit
                    Cells(i, 7).Value = Cells(i, 14).Value
                End If
            Else: 'Gross Debit
                Cells(i, 9).Value = Cells(i, 9).Value * (-1)
                Cells(i, 7).Value = Cells(i, 9).Value
            End If
        Else: 'Gross Credit
            Cells(i, 7).Value = Cells(i, 10).Value
        End If
    Next i
    
    For i = 1 To rowges
        If Cells(i, 5).Value = "Balancetransfer" Then
            og = Cells(i, 5).Value
            Cells(i, 5).Value = Cells(i, 2).Value
            Cells(i, 2).Value = og
            Cells(i, 5).Value = Cells(i, 5).Value & " " & Cells(i, 6).Value
        ElseIf Cells(i, 5).Value = "Chargeback" Then
            og = Cells(i, 5).Value
            Cells(i, 5).Value = Cells(i, 2).Value
            Cells(i, 2).Value = og
        ElseIf Cells(i, 5).Value = "DepositCorrection" Then
            og = Cells(i, 5).Value
            Cells(i, 5).Value = Cells(i, 2).Value
            Cells(i, 2).Value = og
            Cells(i, 5).Value = Cells(i, 5).Value & " " & Cells(i, 6).Value
        ElseIf Cells(i, 5).Value = "Fee" Then
            og = Cells(i, 5).Value
            Cells(i, 5).Value = Cells(i, 2).Value
            Cells(i, 2).Value = og
            Cells(i, 5).Value = Cells(i, 5).Value & " " & Cells(i, 6).Value
        ElseIf Cells(i, 5).Value = "InvoiceDeduction" Then
            og = Cells(i, 5).Value
            Cells(i, 5).Value = Cells(i, 2).Value
            Cells(i, 2).Value = og
            Cells(i, 5).Value = Cells(i, 5).Value & " " & Cells(i, 6).Value
        ElseIf Cells(i, 5).Value = "MerchantPayout" Then
            og = Cells(i, 5).Value
            Cells(i, 5).Value = Cells(i, 2).Value
            Cells(i, 2).Value = og
            Cells(i, 5).Value = Cells(i, 5).Value & " " & Cells(i, 6).Value
        ElseIf Cells(i, 5).Value = "Refunded" Then
            og = Cells(i, 5).Value
            Cells(i, 5).Value = Cells(i, 2).Value
            Cells(i, 2).Value = og
        End If
    Next i
    
    gh = (CInt(rowges) * -1) + 1 'Ges Fees
    Cells(CInt(rowges) + 1, 4).Value = Cells(rowges, 4).Value 'Datum bernehmen
    Cells(CInt(rowges) + 1, 2).Value = "Commission and Fees Adyen"
    Cells(CInt(rowges) + 1, 15).FormulaR1C1 = "=SUM(R[" & gh & "]C:R[-1]C)"
    Cells(CInt(rowges) + 1, 16).FormulaR1C1 = "=SUM(R[" & gh & "]C:R[-1]C)"
    Cells(CInt(rowges) + 1, 17).FormulaR1C1 = "=SUM(R[" & gh & "]C:R[-1]C)"
    Cells(CInt(rowges) + 1, 18).FormulaR1C1 = "=SUM(R[" & gh & "]C:R[-1]C)"
    Cells(CInt(rowges) + 1, 7).FormulaR1C1 = "=SUM(R[" & gh & "]C:R[-1]C)"
    Cells(CInt(rowges) + 1, 7).Value = Cells(CInt(rowges) + 1, 7).Value * -1
    
    Range("G1").Value = "Betrag"
    
    Columns("A:A").NumberFormat = "0"
    
    With Application
        Application.UseSystemSeparators = True
    End With
End Sub

